/*******************************************************************************
*   W[      FAvP[VOP O[oϐ            *
*   W[x    Fapp01_InitVar_MEF                                    *
*   R[OV[PXFvoid app01_InitVar_MEF()                             *
*   쐬E쐬      F2012/4/23     Y.K.                                   *
*                                                                              *
*   Q				F  app01_InitVar.c QƂ̂       *
*   				F  EDIT́AEXTg (MEFISTOϑ)*
*                                                                              *
*   Modified            : 2012/12/27    Y.K.  MEF SWEEP check-sum              *
*   Modified            : 2017/11/17    Kumamoto  Init variables               *
*******************************************************************************/
#include "app_common.h"
#include "app_MEF.h"


unsigned char	app01_InitVar_MEF()
{
	int		i;										//
	
	// *******************
	// ***** MEF-OBS *****
	// *******************
	G1uc_MEF_E2PROM_sum 	= 						// SWEEP-SUM
	G1uc_MEF_E2PROM			= 0x00;					//	MEF: E2PROM operation (128B x4) -- 1:start 2:Write-1 3:Write-2 4:Write-3 5:Write-4 0:none


	// **********************
	// ***** MEF-COMMON *****
	// **********************
	for (i=0; i<36; i++)  Guc_MEF_HK[i]=0;			// MEFISTO-HK made by MEFISTO FPGA


	// *************************
	// ***** MEF-Extension *****
	// *************************
	Gus_MEF_D_Timer    = 0;							// MEFISTO/Deploy: Timer (Remaining time [sec])
	Guc_MEF_D_Off_Chk  = 0;							// MEFISTO/Deploy: Drive off control: Enable/Disable
	Guc_MEF_D_Off_Chk2 = 0;							//AK120805// MEFISTO/Deploy: Drive off control: Enable/Disable
	Guc_MEF_D_Off_Res1 = 0;							// MEFISTO/Deploy: Drive off control: Action/No Action
	Guc_MEF_D_Off_Res2 = 0;							// MEFISTO/Deploy: Drive off control: ON->OFF / OFF->OFF
	for (i=0; i<32; i++)  Guc_MEF_D_Off_Det[i]=0;	// MEFISTO/Deploy: Drive off control: History of Event Detection
	Gi_MEF_D_STEP      = 0;							// MEFISTO/Deploy: Step counter value in last HK
	Guc_MEF_Cmd_Cnt=0;								// MEFISTO Command Counter
	Gi_MEF_D_LEN1=0xFFFF;							//AK120804// Reference value of the S1 length counter
	Gi_MEF_D_LEN2=0xFFFF;							//AK120804// Reference value of the S2 lenght counter
	Gi_MEF_D_STEP_H=0xFFFF;							//AK120804// Reference value of the step counter
	Gi_MEF_D_Para_LA=0x0309;						//AK171111-2// Parameter for consistency check between Deploy&Step counters.
	Gi_MEF_D_Para_LB=0x048E;						//AK171111-2// Parameter for consistency check between Deploy&Step counters.
	Gi_MEF_D_Para_LD=0x03;							//AK171111-2// Parameter for allowed difference between Deploy1&2 counters.
	Guc_MEF_D_Para_TU=0xBB;							//AK171111-2// Parameter for upper limit check of motor temperature.
	Guc_MEF_D_Para_TL=0x87;							//AK171111-2// Parameter for lower limit check of motor temperature.
	Guc_MEF_D_EMG2=0;								//AK171111// Not used while DRV-watch is DIS. To be reset when DRV-watch starts.

	// ******************
	// ***** MEF-HV *****
	// ******************
	Guc_MEF_H_Para_NL = 0;							//AK171111// Not used while HV control is DIS. Overwritten when HV control starts.
	Guc_MEF_H_Para_NU = 0;							//AK171111// Not used while HV control is DIS. Overwritten when HV control starts.
	Guc_MEF_H_Para_PL = 0;							//AK171111// Not used while HV control is DIS. Overwritten when HV control starts.
	Guc_MEF_H_Para_PU = 0;							//AK171111// Not used while HV control is DIS. Overwritten when HV control starts.
	Guc_MEF_H_Off_Chk = 0;							//AK171111// HV control should be DIS(0) at start up.
	Guc_MEF_H_Off_Res = 0;							//AK171111// History flag of HV control should be NON(0) at start up.
	for (i=0;i<32;i++) Guc_MEF_H_Off_Det[i]=0;		//AK171111// Detection log of HV control should be NON(0) at start up.

	return(0);
}


/*
unsigned char	app01_ErrClr_MEF()
{

	return(0);
}
*/
