/*******************************************************************************
*   W[      FAPP01 - CMD from DMC to DPU (for MWE task)           *
*   쐬E쐬      F2012/06/22    Y.K.                                   *
*                                                                              *
*   Q                F  app01_DPU.c QƂ̂                           *
*   				F  EDIT́AEXTg                                  *
*                                                                              *
*   ύX            F2012/7/18     A.K.                                   *
*                         [hƍ@\iR}htjǉ             *
********************************************************************************/
#include 	"app_common.h"
#include 	"app_MWE.h"
	
// *** Prototype - Local ***
unsigned char	app01_MWE            ( unsigned int,  unsigned char * , int);
//
unsigned char	app01_InitVar_MWE    ( void );



// ********************************
// *** CMD analyses / execution ***
// ********************************
unsigned char	app01_MWE  ( unsigned int ui_Cntl, unsigned char uc_Data[], int i_Size )
{
	unsigned char	uc_flag = 0;

	switch (ui_Cntl) {
		// --------------------------------------------------------
		// ----- Admin --------------------------------------------
		// --------------------------------------------------------
		case 0x0000:	if (i_Size!=0) return(0xFF);
						uc_flag = app01_InitVar_MWE();							// MD*U_MWE_INIT
						break;													//AK110708//
		
		// ***********************************
		// **** WPT-S Deployment Timer Set ***
		// ***********************************
		//AK// WPT Deployment Timer Set (Start/Stop/Flag Clear)
		case 0x8000:												//AK// WPT-Timer-set
			if (i_Size!=2) return(0xFF);							//AK120719//
			Gus_MWE_WPT_Timer =uc_Data[0]; Gus_MWE_WPT_Timer*=256;	//AK// Limit [sec]
			Gus_MWE_WPT_Timer+=uc_Data[1];							//AK//
			Gus_MWE_WPT_Timer_Hist=0;								//AK// Flag claer (The DRV-HK just before MDP DRV-Off)
			uc_flag=0;												//AK//
			break;													//AK//

		//AM// MST Deployment Timer Set (Start/Stop/Flag Clear)
		case 0x8101:												//AM// MST-Timer-set
			if (i_Size!=2) return(0xFF);							//AK120719//
			Gus_MWE_MST_Timer =uc_Data[0]; Gus_MWE_MST_Timer*=256;	//AM// Limit [sec]
			Gus_MWE_MST_Timer+=uc_Data[1];							//AM//
			Gus_MWE_MST_Timer_Hist=0;								//AM// Flag claer (The DRV-HK just before MDP DRV-Off)
			uc_flag=0;												//AM//
			break;													//AM//

		case 0x9000:							//AK120718//  // STAT-CHK for WPT-DRV
			if (i_Size!=6) return(0xFF);		//AK120718//
			Guc_MWE_stat_chk = 0x01;			//AK120718//
			Guc_MWE_stat_para1 = uc_Data[0];	//AK120718//
			Guc_MWE_stat_para2 = uc_Data[1]; 	//AK120718//
			Guc_MWE_stat_para3 = uc_Data[2];	//AK120718//
			Guc_MWE_stat_para4 = uc_Data[3]; 	//AK120718//
			Guc_MWE_stat_para5 = uc_Data[4];	//AK120718//
			Guc_MWE_stat_para6 = uc_Data[5]; 	//AK120718//
			Guc_MWE_stat_log = 0x00;			//AK120718//
			uc_flag = 0;						//AK120718//
			break;								//AK120718//

		case 0x9101:							//AK120718//  // STAT-CHK for MST-DRV
			if (i_Size!=6) return(0xFF);		//AK120718//
			Guc_MWE_stat_chk2 = 0x01;			//AK120718//
			Guc_MWE_stat_para1 = uc_Data[0];	//AK120718//
			Guc_MWE_stat_para2 = uc_Data[1]; 	//AK120718//
			Guc_MWE_stat_para3 = uc_Data[2];	//AK120718//
			Guc_MWE_stat_para4 = uc_Data[3]; 	//AK120718//
			Guc_MWE_stat_para5 = uc_Data[4];	//AK120718//
			Guc_MWE_stat_para6 = uc_Data[5]; 	//AK120718//
			Guc_MWE_stat_log = 0x00;			//AK120718//
			uc_flag = 0;						//AK120718//
			break;								//AK120718//

		// ***********************************************
		// **** WPT-S1 DRV-ON -> OFF [for HRM release] ***
		// ***********************************************
		case 0xC101:
			if (i_Size!=0) return(0xFF);
			Guc_MWE_WPTSext = 0x01;									// Non-exe, WPT-S1:ENA
			uc_flag = 0;
			break;

		// ***********************************************
		// **** WPT-S2 DRV-ON -> OFF [for HRM release] ***
		// ***********************************************
		case 0xC202:
			if (i_Size!=0) return(0xFF);
			Guc_MWE_WPTSext = 0x02;									// Non-exe, WPT-S2:ENA
			uc_flag = 0;
			break;

		default:		uc_flag = 0xFF;											break;	// *** Error: CMD not found ***
	}
	return( uc_flag );
}
// **********************************************************************************************************

