/*******************************************************************************
*   W[      FO[oϐ`                                   *
*   W[x    Fvariable - COMMON                                    *
*   ^XN敪          Fwb_                                               *
*   @\                FCOMMONϐ`                                       *
*   gp̒        FɂȂ                                             *
*   쐬E쐬      F2014/6/12     Y.K.                                   *
*******************************************************************************/
#include "dpu_api.h"
#include "app_core.h"

// *********************************************************
// *  VARIABLES - PARAMETERS                               *
// *********************************************************
// ----------------------------
// Operation Status
// ----------------------------
volatile unsigned char		Guc_OpeMode;					// 0:NRM   1:Cruise		(1bit)


// *********************************************************
// *  VARIABLES - PARAMETERS                               *
// *********************************************************
// -----------------------------------------
// <<<< APP02 >>>> Mission-TLM: HK
// -----------------------------------------
volatile unsigned char		Guc_HK_link   [0x15];			// HK Link    status	(1bit)
volatile unsigned char		Guc_HK_link0  [0x15];			// HK Link    status	(1bit)
volatile unsigned char		Guc_TLMhk_cmp [0x15];			// TLM-LM Dump: Compress	  (0:non 1:Math) [set by MD?U_CMPSET]

// -----------------------------------------
// <<<< APP03/04 >>>> Mission-TLM: L/M
// -----------------------------------------
volatile unsigned char		Guc_TLMm_cmp      [0x13];		// TLM-LM Dump: Compress	  (0:non 1:JPEG-Rev 2:Math 3-7:User-def.) [set by MD?U_CMPSET]
volatile unsigned int		Gui_TLMm_blockTime[0x13];		// TLM-LM Dump: Processed TI  (LSB:31.25msec)

// -----------------------------------------
// <<<< APP05 >>>>    Mission-TLM: H
// -----------------------------------------
volatile unsigned char		Guc_TLMh_cmp      [0x13];		// TLM-H Dump:  Compress      (0:non 1:JPEG-Rev 2:Math 3-7:User-def.) [set by MD?U_CMPSET]
volatile unsigned int		Gui_TLMh_blockTime[0x13];		// TLM-H Dump:  Processed TI  (LSB:31.25msec)

// -----------------------------------------
// <<<< APP03 >>>>    TRIGGER DATA
// -----------------------------------------
//#define					Gd_TRG_MAX	   		20					// 20 spin (80-100sec)			(0:latest)
// *** DPU1 ***
unsigned int		Gui_TRG1_Cnt;							// Counter
unsigned int		Gui_TRG1_SpTI      [Gd_TRG_MAX];		// TI            at Sun Pulse (LSB:31.25 msec)
unsigned int		Gui_TRG1_SpTI_s    [Gd_TRG_MAX];		// TI            at Sun Pulse (LSB: 1.925msec)
unsigned short		Gus_TRG1_Score     [Gd_TRG_MAX];		// DPU1 - SCORE
// 
short				Gs_TRG1_MGFO_Bx    [Gd_TRG_MAX];		// MGFO - Bx
short				Gs_TRG1_MGFO_By    [Gd_TRG_MAX];		// MGFO - By
short				Gs_TRG1_MGFO_Bz    [Gd_TRG_MAX];		// MGFO - Bz
unsigned short		Gus_TRG1_MGFO_Brms [Gd_TRG_MAX];		// MGFO - Brms
// 
unsigned short		Gus_TRG1_MIA_N     [Gd_TRG_MAX];		// MIA  - N
short				Gs_TRG1_MIA_Vx     [Gd_TRG_MAX];		// MIA  - Vx
short				Gs_TRG1_MIA_Vy     [Gd_TRG_MAX];		// MIA  - Vy
short				Gs_TRG1_MIA_Vz     [Gd_TRG_MAX];		// MIA  - Vz
unsigned short		Gus_TRG1_MIA_T     [Gd_TRG_MAX];		// MIA  - T
unsigned char		Guc_TRG1_MIA_Esp   [Gd_TRG_MAX][7];		// MIA  - ET
//
unsigned short		Gus_TRG1_MEA_T     [Gd_TRG_MAX];		// MEA  - T
char				Gc_TRG1_MSA_HIon   [Gd_TRG_MAX];		// MSA  - HeavyIon
//
char				Gc_TRG1_ENA        [Gd_TRG_MAX];		// ENA  - Trigger
//
unsigned short		Gus_TRG1_HEPE_Flux [Gd_TRG_MAX];		// HEPE - FLUX
unsigned short		Gus_TRG1_HEPE_FluxH[Gd_TRG_MAX];		// HEPE - FLUX
//unsigned short	Gus_TRG1_HEPI_Flux [Gd_TRG_MAX];		// HEPI - FLUX
//

// *** DPU2 ***
unsigned int		Gui_TRG2_Cnt;							// Counter
unsigned int		Gui_TRG2_SpTI      [Gd_TRG_MAX];		// TI            at Sun Pulse (LSB:31.25 msec)
unsigned int		Gui_TRG2_SpTI_s    [Gd_TRG_MAX];		// TI            at Sun Pulse (LSB: 1.925msec)
unsigned short		Gus_TRG2_Score     [Gd_TRG_MAX];		// DPU2 - SCORE
//
short				Gs_TRG2_EFD_Pot    [Gd_TRG_MAX];		// EFD - Potential	(+-100V			0->+MAX:0000->7FFF -1->-MAX:FFFF->8000
unsigned short		Gus_TRG2_EFD_E     [Gd_TRG_MAX];		// EFD - |E|		(0-500mV/m)		0->+MAX:0000->FFFF
unsigned short		Gus_TRG2_EFD_Erms  [Gd_TRG_MAX];		// EFD - |E|		(0-500mV/m)		0->+MAX:0000->FFFF
unsigned char		Guc_TRG2_EWO_Esp   [Gd_TRG_MAX][8];		// EWO - Spectrum	(LOG dB)		0:-128dB FF:0dB (V/m/Hz)
															//											Freq: 2step in 1 order (10Hz - 10k)
unsigned char		Guc_TRG2_EWO_Bsp   [Gd_TRG_MAX][8];		// EWO - Spectrum	(LOG dB)		0:-128dB FF:0dB (V/m/Hz)
															//											Freq: 2step in 1 order (10Hz - 10k)
//
unsigned char		Guc_TRG2_SOR_N     [Gd_TRG_MAX];		// SORBET e- N						Fp  = (value) x 10Hz [DEC?]
unsigned char		Guc_TRG2_SOR_T     [Gd_TRG_MAX];		// SORBET e- Temp index				QTN = (value) x 1dB [DEC?]
//
short				Gs_TRG2_MGFI_Bx    [Gd_TRG_MAX];		// MGFI - Bx			****TBD****
short				Gs_TRG2_MGFI_By    [Gd_TRG_MAX];		// MGFI - By			****TBD****
short				Gs_TRG2_MGFI_Bz    [Gd_TRG_MAX];		// MGFI - Bz			****TBD****
unsigned short		Gus_TRG2_MGFI_Brms [Gd_TRG_MAX];		// MGFI - Brms			****TBD****


// -----------------------------------------
// EXCHANGE DATA
// -----------------------------------------
// --- DATA EXCHANGE: MDM (to PWI) ---
unsigned int		Gui_MDM_data_TI;					// MDM (for PWI): 	TI of DATA
unsigned short		Gus_MDM_data_dt;					// MDM (for PWI): 	TI of DATA
unsigned char		Guc_MDM_data_priority;				// MDM (for PWI): 	Priority 	B7(MSB)	1:event	0:noise
unsigned char		Guc_MDM_data[960];					// MDM - data
int					Gi_MDM_numPacket;					// MDM - stored packet num.

// SOR
unsigned char		Guc_SOR_LM;

// *********************************************************
// *  VARIABLES - WORK AREA                                *
// *********************************************************
// --- Common Work area in APP02/03/04/05 ---
// #define  				Gd_dataHkLen		1280				// SDRAM-HK 	 	max length	***FM version (100804) [MDP-MW:408B]***
// #define  				Gd_dataPacLen		0x2000				// Packet edit 		max length	8kB - max [Packet size to DMC: 1kB-	max]
// #define  				Gd_dataRawLen		 0xD000				//									DPU1: max --  49408B	[ENA]  	(1 block)

unsigned char		G2uc_packet [Gd_dataHkLen ];			// for APP02:	HK data reduction	(overwritten by others!)
unsigned char		G03uc_packet[Gd_dataPacLen];			// for APP03:	Packet data etc.	(overwritten by others!)
unsigned char		G13uc_packet[Gd_dataPacLen];			// for APP13:	Packet data etc.	(overwritten by others!)
unsigned char		G04uc_packet[Gd_dataPacLen];			// for APP04:	Packet data etc.	(overwritten by others!)
unsigned char		G14uc_packet[Gd_dataPacLen];			// for APP14:	Packet data etc.	(overwritten by others!)
unsigned char		G5uc_packet [Gd_dataPacLen];			// for APP05:	Packet data etc.	(overwritten by others!)
unsigned char		G6uc_packet [Gd_dataPacLen];			// for APP06:	Packet data etc.	(overwritten by others!)
//
unsigned char		G2uc_data   [Gd_dataHkLen ];			// for APP02:	HK data read		(overwritten by others!)
unsigned char		G03uc_data  [Gd_dataRawLen];			// for APP03:	Block  data etc.	(overwritten by others!)
unsigned char		G13uc_data  [Gd_dataRawLen];			// for APP13:	Block  data etc.	(overwritten by others!)
unsigned char		G04uc_data  [Gd_dataRawLen];			// for APP04:	Block  data etc.	(overwritten by others!)
unsigned char		G14uc_data  [Gd_dataRawLen];			// for APP14:	Block  data etc.	(overwritten by others!)
unsigned char		G5uc_data   [Gd_dataRawLen];			// for APP05:	Block  data etc.	(overwritten by others!)
//
unsigned char		Guc_cmdDummy[266];						// buffer - Dummy

/*
// --- Compression: MATH ---
unsigned char		Guc_math_in_data [ Gd_dataPacLen ];		// 00002000
unsigned char		Guc_math_out_data[ Gd_dataPacLen ];		// 00002000
short        		Gs_math_totals   [ 258 ];  				// 00000204
unsigned int  	 	Gui_math_counts  [ 256 ];				// 00000400
unsigned char 	 	Guc_math_scaled_counts[256];			// 00000100
*/
