/* *******************************************************************
  app_math_math.c

  ====================================================================
  void app_math_init_table()
  --------------------------------------------------------------------
  @\F  	L̔zɁCOp֐̃e[u쐬
				z񖼁ETCYF	Gf_math_sin_table[N_SIN_TABLE + 1]
				ĹCN_SIN_TABLE  512 ̏ꍇłTC2048 ̏ꍇ 7 D
				̑̐w֐gpJnOɁCKxs邱ƁD
  F	
  ߂lF	
  ====================================================================
  double app_math_sin( double f_rad )
  double app_math_cos( double f_rad )
  --------------------------------------------------------------------
  @\F  	ʑiradianj^ƁCOp֐ sin  cos ̒lԂD
  F	double	f_rad		ʑiradianj
  ߂lF	sin  cos ̒l
  ====================================================================
  double app_math_atan( double f_tangent )
  --------------------------------------------------------------------
  @\F	Tangent l^ƁCΊpiradianjԂD
  			ΊṕC0    2 ͈̔͂ŕԂD
  F	double	f_rad		Tangent l
  ߂lF	ΊpiradianC0    2΁j
  ====================================================================
  double app_math_log( double f_org )
  --------------------------------------------------------------------
  @\F	l^ƁC̎RΐԂD
  			lOȉ̏ꍇC\Ȍ蕉ɑ傫Ԃi{C-Inf.jD
  F	double	f_org		Rΐ߂li f_org > 0 j
  ߂lF	Rΐ
  ====================================================================
  double app_math_log10( double f_org )
  --------------------------------------------------------------------
  @\F	l^ƁC̏pΐԂD
  			lOȉ̏ꍇC\Ȍ蕉ɑ傫Ԃi{C-Inf.jD
  F	double	f_org		pΐ߂li f_org > 0 j
  ߂lF	pΐ
  ====================================================================
  double app_math_exp( double f_org )
  --------------------------------------------------------------------
  @\F	w^ƁC e ƂׂԂD
  F	double	f_org		e Ƃׂ߂w
  ߂lF	e ׂ̂
  ====================================================================
  double app_math_pow( double f_base, double f_exp )
  --------------------------------------------------------------------
  @\F	Ǝw^ƁCׂԂD
  F	double	f_base		ׂ߂
  			double	f_exp		ׂ߂w
  ߂lF	ׂ
  ====================================================================
  double app_math_sqrt( double f_org )
  --------------------------------------------------------------------
  @\F	l^ƁC̕ԂD
  F	double	f_org		߂li f_org > 0 j
  ߂lF	
  ====================================================================
  double app_math_rad2deg( double f_rad )
  --------------------------------------------------------------------
  @\F	Radian ^ƁCdegree ԂD
			߂l 0    360 ͈̔͂ŕԂD
  F	double	f_rad		ʑiradianj
  ߂lF	ʑidegree, 0    360j
  ====================================================================
  double app_math_regulate_rad( double f_rad )
  --------------------------------------------------------------------
  @\F	ʑiradianj 0    2 ͈̔͂ɐKD
  F	double	f_rad		ʑiradianj
  ߂lF	ʑiradian, 0    2΁j
  ====================================================================
 ******************************************************************* */
#include		"app_common.h"

#define 		MATH_PI        (3.1415926536)
#define 		MATH_LN10      (2.302585093)
#define 		MATH_N_NEWTON  10

/*
double app_math_sin( double f_rad );
double app_math_cos( double f_rad );
double app_math_atan( double f_tangent );
double app_math_log( double f_org );
double app_math_log10( double f_org );
double app_math_exp( double f_org );
double app_math_pow( double f_base, double f_exp );
double app_math_sqrt( double f_org );
double app_math_rad2deg( double f_rad );
double app_math_regulate_rad( double f_rad );
*/


// sin e[u𐶐
void app_math_init_table(){
	double	f_rad, f_val, f_tmp;
	double	f_i;
	int	i;
	
	// sin ̒lz𐶐D
	// 0   < /2 ͈̔͂ N_SIN_TABLE ŕD
	for( i=0; i<Gd_N_SIN_TABLE; i++ ){
		f_rad = ( MATH_PI / 2 ) / Gd_N_SIN_TABLE * i;
		
		// Taylor ɂ sin vZ
		f_val = f_rad;
		f_tmp = f_rad;
		for ( f_i = 1; f_i < 9; f_i++ ) {
			f_tmp = - f_tmp * f_rad * f_rad / ( ( 2 * f_i ) * ( 2 * f_i + 1 ) );
			f_val += f_tmp;
		}
		
		// zɎ[
		Gf_math_sin_table[i] = f_val;
	}
	Gf_math_sin_table[Gd_N_SIN_TABLE] = 1.0;
}


// sin e[uǂ݁C⊮D
double app_math_read_table( double f_rad ){
	int		i_num1, i_num2;
	double	f_val, f_val1, f_val2;
	double	f_delta, f_diff;
	
	// e[u̔zԍvZ
	i_num1 = (int)( Gd_N_SIN_TABLE * f_rad / ( MATH_PI / 2 ) );
	i_num2 = i_num1 + 1;
	
	// e[u̓ǂݏo
	f_val1 = Gf_math_sin_table[i_num1];
	f_val2 = Gf_math_sin_table[i_num2];
	
	// ⊮
	f_delta = ( MATH_PI / 2 ) / Gd_N_SIN_TABLE;
	f_diff = ( f_rad - ( f_delta * i_num1 ) ) / f_delta;
	f_val = f_val1 + ( f_val2 - f_val1 ) * f_diff;
	
	return f_val;
}


double 	app_math_sin( double f_rad )
{
	double 	f_val, f_sign;
// 	double 	f_i;							// **** REVISED:110618 by YK ****
	
	// ʑ 0 <=  < 2 ͈̔͂Ƀu`Jbg
	f_rad = app_math_regulate_rad( f_rad );
	
	//  <=  < 2 :	 -  ŌvZC-1 {
	if( f_rad < MATH_PI ){
		f_sign = 1;
	}
	else{
		f_sign = -1;
		f_rad -= MATH_PI;
	}
	
	// 0 <=  < /2 :	̂܂
	if( f_rad < MATH_PI / 2 ){
		f_val = app_math_read_table( f_rad ) * f_sign;
	}
	// /2 <=  <  :	 -  ŌvZ
	else{
		f_val = app_math_read_table( MATH_PI - f_rad ) * f_sign;
	}
	
  	return f_val;
}


double 	app_math_cos( double f_rad )
{
  	return app_math_sin( f_rad + MATH_PI / 2 );
}


double 	app_math_atan_base( double f_tangent )
{
  	double	f_tmp1, f_tmp2, f_tmp3, f_val;
  	int	i;

  	f_val = f_tangent;
  	f_tmp1 = f_tangent;
  	f_tmp3 = 3;
  	for ( i=0; i<10; i++ ) {
    	f_tmp1 = - f_tmp1 * f_tangent * f_tangent;
    	f_tmp2 = f_tmp1 / f_tmp3;
    	f_val += f_tmp2;
    	f_tmp3 += 2;
  	}

  return f_val;
}


double 	app_math_atan( double f_tangent ) {
  	double	f_param, f_val;

  	// ̏ꍇ́C񕄍𔽓]D
  	if ( f_tangent < 0 ){
    	f_param = - f_tangent;
  	}
  	else {
    	f_param = f_tangent;
  	}

  	// 傫 0.5 ̏ꍇĈ܂ Taylor ŌvZD
  	if ( f_param < 0.5 ) {
    	f_val = app_math_atan_base( f_param );
  	}
  	// 傫 1 ̏ꍇC@藝ɊÂCʂ 1/2 ɂȂ悤
  	// vZĂQ{D
  	else if ( f_param < 1 ) {
    	f_param = ( -1 + app_math_sqrt( 1 + f_param * f_param ) ) / f_param;
    	f_val = app_math_atan_base( f_param );
    	f_val *= 2;
  	}
  
  	// 傫 2 ̏ꍇCtɂāC@藝ɊÂCʂ 1/2 
  	// Ȃ悤ɌvZĂQ{C/2 獷D
  	else if ( f_param < 2 ) {
    	f_param = 1 / f_param;
    	f_param = ( -1 + app_math_sqrt( 1 + f_param * f_param ) ) / f_param;
    	f_val = app_math_atan_base( f_param );
    	f_val *= 2;
    	f_val = MATH_PI / 2 - f_val;
  	}
  	// 傫 2 ȏ̏ꍇCtɂČvZC/2 獷D
  	else {
    	f_param = 1 / f_param;
    	f_val = app_math_atan_base( f_param );
    	f_val = MATH_PI / 2 - f_val;
  	}
  	
  	// ̏ꍇ́Cʂ̕Ĕ]D
  	if( f_tangent < 0 ){
    	f_val *= -1;
  	}

  	// ʂ 0 < theta < 2 ɐKD
  	f_val = app_math_regulate_rad( f_val );
  
  	return f_val;
}


double 	log_base( double f_org )
{
  	double	f_x;
  	double	f_tmp1, f_tmp2, f_tmp3, f_val;
  	int		i;

  	f_x = f_org - 1;

  	f_val = f_x;
  	f_tmp1 = f_x;
  	f_tmp3 = 2;
  	for ( i=0; i<10; i++ ) {
    	f_tmp1 = - f_tmp1 * f_x;
    	f_tmp2 = f_tmp1 / f_tmp3;
    	f_val += f_tmp2;
    	f_tmp3++;
  	}
  
  	return f_val;
}


double app_math_log( double f_org )
{
  	double	f_param, f_val;
  	int	i, j;
	
	// 1e30 ȏ̏ꍇCInf ƌȂ\Ȍ傫Ԃi{ Infj
	if( f_org >= 1e30 ){
		return 1e30;
	}
	
  	// 0 ȉ̏ꍇC\Ȍ蕉ɑ傫Ԃi{ -InfjD
  	if( f_org <= 0 ){
    	return -1e30;
  	}

  	// Taylor Ő܂ 1 t߂ɂȂ܂ŕD
  	for ( i=0, f_param = f_org; f_param > 1.3; i++ ){
    	f_param = app_math_sqrt( f_param );
  	}

  	f_val = log_base( f_param );

  	// 񐔂Q{D
  	for ( j=0; j<i; j++ ) {
    	f_val *= 2;
  	}

  	return f_val;
}


double app_math_log10( double f_org )
{
  	double	f_val;

  	f_val = app_math_log( f_org );
  	f_val /= MATH_LN10;

  	return f_val;
}


double 	app_math_exp( double f_org )
{
	int		i_org_sign;
	double	f_org_abs;
	int		i_times;
	double	f_base;
  	double	f_val, f_tmp1, f_tmp2;
  	double	f_i;
  	int		i;

	// w̐ΒlC
	if( f_org < 0 ){
		i_org_sign = -1;
		f_org_abs = f_org * -1;
	}
	else{
		i_org_sign = 1;
		f_org_abs = f_org;
	}
	
	// lPȉƂȂ܂ŁCwQŏZ
	for( f_base = f_org_abs, i_times = 0; f_base > 1; i_times++ ){
		f_base /= 2;
	}

	// Taylor  exp vZ
  	f_val = 1;
  	f_tmp1 = 1;
  	f_tmp2 = 1;
  	for ( f_i = 1; f_i < 12; f_i++ ){
		f_tmp1 *= f_base;	// Taylor ̕q
		f_tmp2 *= f_i;		// Taylor ̕
    	f_val += f_tmp1 / f_tmp2;
  	}
  
  	// QŏZ񐔂
  	for( i=0; i<i_times; i++ ){
		f_val *= f_val;
  	}
  
  	// w̏ꍇCtɂ
	if( i_org_sign < 0 ){
		f_val = 1 / f_val;
	}
  
  	return f_val;
}


double app_math_pow( double f_base, double f_exp )
{
	// x^y ̏ꍇCexp( y * log( x ) ) ԂD
	return app_math_exp( f_exp * app_math_log( f_base ) );
}


double app_math_sqrt( double f_org )
{
  	double	f_x, f_s, f_last;
  	int	i;

	f_x = f_org;

	if( f_x <= 0.0 ) return 0.0;
	if( f_x > 1 )	f_s = f_x;
	else			f_s = 1;
	
	i = 0;
	do {
		i++;
		f_last = f_s;
		f_s = ( f_x / f_s + f_s ) * 0.5;
	} while( f_s < f_last );

  
  	return f_last;
}


/*
double app_math_rad2deg( double f_rad )
{
  	double f_deg;

  	f_deg = f_rad * 180 / MATH_PI;
  	f_deg -= (int)( f_deg / 360 ) * 360;
  	if ( f_deg < 0 ) f_deg += 360;
  
  	return f_deg;
}
*/


double app_math_regulate_rad( double f_rad )
{
	f_rad -= (double)( (int)( f_rad / ( MATH_PI * 2  ) ) ) * MATH_PI * 2;
	
	if ( f_rad < 0 ){
		f_rad += MATH_PI * 2;
	}

  	return f_rad;
}
