/*******************************************************************************
*   W[      FAPP EWO Common - Variables definitions               *
*   W[x    FvariableApp EWO                                      *
*   ^XN敪          Fwb_                                               *
*   @\                FO[oϐ`s                             *
*                   F SampleƂāA app_variable.c QƂ̂          *
*   쐬E쐬      F2018/1/12  	Y.K.				      *
*******************************************************************************/
#define __APP_EWO_VARIABLE_C__
#include "app_ewo.h"

// **********************
// ***** EWO-COMMON *****
// **********************
// E2PROM Write		in APP01 & 02
unsigned char		G1uc_EWO_E2PROM;		//	EWO: E2PROM operation:	1:start 2:EFD-LPF(1) 3:EFD-LPF(2) 4:EFD-SWEEP 5:EWOB-LPF 6:Hungary-table 0:none

// Relays initialization
unsigned char		G1uc_EWO_relay_init;

// EFD-SWEEP TABLE
unsigned char		Guc_EFD_SweepTbl;		//  EFD-table in ROM: 0-3
unsigned char		Guc_EFD_SweepTbl_sum;	//  EFD-table check sum
unsigned char		G1uc_EFD_Sweep_Load;	//  n/a:0  load:1

// Data mode		in APP03
unsigned char		Guc_EFD_mode;				//	***TMP*** EFD-SPB: 0:ave 1:deci

// Antenna angle (SSAS: 225deg)
unsigned short		Gus_EWO_Ec_X1ang;			//	X1(WPT-S1:  0) eclipse angle
//unsigned short	Gus_EWO_Ec_Y1ang;			//	Y1(MEF-S1: 90) eclipse angle
//unsigned short	Gus_EWO_Ec_X2ang;			//	X2(WPT-S2:180) eclipse angle
//unsigned short	Gus_EWO_Ec_Y2ang;			//	Y2(MEF-S2:270) eclipse angle

// MDM-EWO
unsigned char		Guc_EwoMdmData_after;		//	2
unsigned char		Guc_EwoMdmData_before;		//	8


// *******************
// ***** EWO-WFC *****
// *******************

// ************* Written in app_EWO_WFC.h *************

// EWOE/B work area in APP04 [AM2P: E-only, DecimationȂAO]
short				G14s_WFC_X_H[2048];		// Waveform-X-H	 i_dataId=0(65.536kHz,125ms) 	i_dataId=1(349.525kHz,23.5ms)								****TMP****
short				G14s_WFC_Y_H[2048];		// Waveform-Y-H	 i_dataId=0(65.536kHz,125ms) 	i_dataId=1(349.525kHz,23.5ms)								****TMP****

// EWOE/B work area in APP05 (DefimationȂAO)
short				G5s_WFC_X_H[2048];		// Waveform-X-H	 i_dataId=0(65.536kHz,125ms) 	i_dataId=1(349.525kHz,23.5ms)								****TMP****
short				G5s_WFC_Y_H[2048];		// Waveform-Y-H	 i_dataId=0(65.536kHz,125ms) 	i_dataId=1(349.525kHz,23.5ms)								****TMP****
short				G5s_WFC_Z_H[2048];		// Waveform-Y-H	 i_dataId=0(65.536kHz,125ms) 	i_dataId=1(349.525kHz,23.5ms)								****TMP****
double				Gf_EWO_compWaveBuf[240];


// **********************************
// ***** EWO-Dicimation filters *****
// **********************************
// Decimation Filters (APP03݂̂ŗpAł΂łnjDAPP04/05łgȂAʁXɒ萔`ȂƂȂB
//					   gp̉\rłBȂ΁ABUSY-flagŌʐKvɂȂB
//#define 			Gd_EWO_DEC_MAX 		8192	    	//  Work area size
//double				Gf_EWO_DEC_work[Gd_EWO_DEC_MAX];	//	Work area
double				G13f_EWO_DEC_work[Gd_EWO_DEC_MAX];	//	Work area (for APP13)
double				G14f_EWO_DEC_work[Gd_EWO_DEC_MAX];	//	Work area (for APP13)

/*		--- comment out		2012.9.19	YK
double				Gf_EWO_DEC_h2[31]  
							= {	-9.71E-04,  1.88E-03,  4.30E-03,  2.19E-03, -5.97E-03,			// 1/2		 31 parameters
								-1.21E-02, -4.26E-03,  1.63E-02,  2.78E-02,  6.53E-03,
								-4.03E-02, -6.35E-02, -8.30E-03,  1.29E-01,  2.78E-01,
								 3.42E-01,  2.78E-01,  1.29E-01, -8.30E-03, -6.35E-02,
								-4.03E-02,  6.53E-03,  2.78E-02,  1.63E-02, -4.26E-03,
								-1.21E-02, -5.97E-03,  2.19E-03,  4.30E-03,  1.88E-03,
								-9.71E-04 };
*/

double	Gf_EWO_DEC_h2_2[25]
			= {	-1.207931668370268e-03,	-4.164311981265589e-03,
				-5.718453385999887e-03,	 4.682126121014196e-04,
				 1.485312569462041e-02,	 2.316270899916421e-02,
				 5.412576332224783e-03,	-3.589702326809492e-02,
				-5.849600613600778e-02,	-7.222015405386823e-03,
				 1.271083898030658e-01,	 2.773786892473849e-01,
				 3.434278844234137e-01,	 2.773786892473849e-01,
				 1.271083898030658e-01,	-7.222015405386823e-03,
				-5.849600613600778e-02,	-3.589702326809492e-02,
				 5.412576332224783e-03,	 2.316270899916421e-02,
				 1.485312569462041e-02,	 4.682126121014196e-04,
				-5.718453385999887e-03,	-4.164311981265589e-03,
				-1.207931668370268e-03 };


double	Gf_EWO_DEC_h2_efd[27]															// 1/2 for EFD		2012.08.22 T.Imachi
			= {	-5.740354774236824e-04, -2.555096061195256e-03,
				-5.117261307493714e-03, -3.985212015510897e-03,
				 5.414911690022135e-03,  1.945745367588452e-02,
				 2.240897307793031e-02, -8.968763052703637e-04,
				-4.102960900063262e-02, -5.554869394115806e-02,
				 2.018023153236153e-03,  1.328080411244583e-01,
				 2.727309034717042e-01,  3.331731939069713e-01,
				 2.727309034717042e-01,  1.328080411244583e-01,
				 2.018023153236153e-03, -5.554869394115806e-02,
				-4.102960900063262e-02, -8.968763052703637e-04,
				 2.240897307793031e-02,  1.945745367588452e-02,
				 5.414911690022135e-03, -3.985212015510897e-03,
				-5.117261307493714e-03, -2.555096061195256e-03,
				-5.740354774236824e-04 };

/*
double				Gf_EWO_DEC_h32[150] 
							= {	-1.16E-04, -8.20E-04, -2.80E-04, -4.40E-04, -5.05E-04,			// 1/32		150 parameters
								-5.91E-04, -6.81E-04, -7.77E-04, -8.78E-04, -9.84E-04,
		    					-1.09E-03, -1.20E-03, -1.32E-03, -1.43E-03, -1.54E-03,
		    					-1.65E-03, -1.75E-03, -1.85E-03, -1.94E-03, -2.02E-03,
		    					-2.09E-03, -2.14E-03, -2.18E-03, -2.20E-03, -2.20E-03,
		    					-2.17E-03, -2.12E-03, -2.04E-03, -1.93E-03, -1.79E-03,
		    					-1.61E-03, -1.40E-03, -1.16E-03, -8.70E-04, -5.44E-04,
		    					-1.77E-04,  2.30E-04,  6.80E-04,  1.17E-03,  1.71E-03,
		    					 2.28E-03,  2.90E-03,  3.55E-03,  4.24E-03,  4.97E-03,
		    					 5.74E-03,  6.53E-03,  7.36E-03,  8.21E-03,  9.08E-03,
		    					 9.97E-03,  1.09E-02,  1.18E-02,  1.27E-02,  1.36E-02,
		    					 1.46E-02,  1.55E-02,  1.64E-02,  1.73E-02,  1.82E-02,
		    					 1.90E-02,  1.98E-02,  2.06E-02,  2.13E-02,  2.20E-02,
		    					 2.26E-02,  2.32E-02,  2.38E-02,  2.42E-02,  2.46E-02,
		    					 2.50E-02,  2.53E-02,  2.55E-02,  2.56E-02,  2.57E-02,
		    					 2.57E-02,  2.56E-02,  2.55E-02,  2.53E-02,  2.50E-02,
		    					 2.46E-02,  2.42E-02,  2.38E-02,  2.32E-02,  2.26E-02,
		    					 2.20E-02,  2.13E-02,  2.06E-02,  1.98E-02,  1.90E-02,
		    					 1.82E-02,  1.73E-02,  1.64E-02,  1.55E-02,  1.46E-02,
		    					 1.36E-02,  1.27E-02,  1.18E-02,  1.09E-02,  9.97E-03,
							     9.08E-03,  8.21E-03,  7.36E-03,  6.53E-03,  5.74E-03,
							     4.97E-03,  4.24E-03,  3.55E-03,  2.90E-03,  2.28E-03,
							     1.71E-03,  1.17E-03,  6.80E-04,  2.30E-04, -1.77E-04,
							    -5.44E-04, -8.70E-04, -1.16E-03, -1.40E-03, -1.61E-03,
							    -1.79E-03, -1.93E-03, -2.04E-03, -2.12E-03, -2.17E-03,
							    -2.20E-03, -2.20E-03, -2.18E-03, -2.14E-03, -2.09E-03,
							    -2.02E-03, -1.94E-03, -1.85E-03, -1.75E-03, -1.65E-03,
							    -1.54E-03, -1.43E-03, -1.32E-03, -1.20E-03, -1.09E-03,
							    -9.84E-04, -8.78E-04, -7.77E-04, -6.81E-04, -5.91E-04,
							    -5.05E-04, -4.40E-04, -2.80E-04, -8.20E-04, -1.16E-04 };
*/

double	Gf_EWO_DEC_h32[156]
			={	-1.898407653893172e-04,	-9.403278250922984e-05,			// 1/32		156 parameters
				-1.159940398487160e-04,	-1.404273520847886e-04,
				-1.673824131170590e-04,	-1.967504435866056e-04,
				-2.282544203200737e-04,	-2.616217785107975e-04,
				-2.967199456778411e-04,	-3.333506997786936e-04,
				-3.708614964568210e-04,	-4.085850549101987e-04,
				-4.466426643827939e-04,	-4.836292956512548e-04,
				-5.193247290669658e-04,	-5.526349048759427e-04,
				-5.826957473746211e-04,	-6.085612035359574e-04,
				-6.292324022329137e-04,	-6.435464593668489e-04,
				-6.502753220265006e-04,	-6.482378016300279e-04,
				-6.361097347320060e-04,	-6.124486551146518e-04,
				-5.760341781234181e-04,	-5.252686628355063e-04,
				-4.588682259308329e-04,	-3.753837344550358e-04,
				-2.734273006941576e-04,	-1.516021567916148e-04,
				-8.594717640895825e-06,	 1.568691933439616e-04,
				 3.460113691458050e-04,	 5.599142515163203e-04,
				 7.995904472920495e-04,	 1.065978752364769e-03,
				 1.359749698954905e-03,	 1.681579756812664e-03,
				 2.031873628978360e-03,	 2.410920127464540e-03,
				 2.818791793300855e-03,	 3.255386488363327e-03,
				 3.720375755386576e-03,	 4.213233003347200e-03,
				 4.733238438935366e-03,	 5.279415155171049e-03,
				 5.850570227535509e-03,	 6.445325874227459e-03,
				 7.062014104279350e-03,	 7.698822264988726e-03,
				 8.353676447074240e-03,	 9.024324608807328e-03,
				 9.708311513369797e-03,	 1.040302331611342e-02,
				 1.110566617194871e-02,	 1.181329618398746e-02,
				 1.252285567837853e-02,	 1.323115989909443e-02,
				 1.393493692774401e-02,	 1.463087065627697e-02,
				 1.531556027004567e-02,	 1.598561896611383e-02,
				 1.663764687048893e-02,	 1.726828371579256e-02,
				 1.787421770875803e-02,	 1.845222828680643e-02,
				 1.899919396165935e-02,	 1.951212601213583e-02,
				 1.998820085610428e-02,	 2.042476113245978e-02,
				 2.081934699848761e-02,	 2.116972978070926e-02,
				 2.147390099682189e-02,	 2.173011855186073e-02,
				 2.193690456603800e-02,	 2.209305676901928e-02,
				 2.219766548720220e-02,	 2.225012437287656e-02,
				 2.225012437287656e-02,	 2.219766548720220e-02,
				 2.209305676901928e-02,	 2.193690456603800e-02,
				 2.173011855186073e-02,	 2.147390099682189e-02,
				 2.116972978070926e-02,	 2.081934699848761e-02,
				 2.042476113245978e-02,	 1.998820085610428e-02,
				 1.951212601213583e-02,	 1.899919396165935e-02,
				 1.845222828680643e-02,	 1.787421770875803e-02,
				 1.726828371579256e-02,	 1.663764687048893e-02,
				 1.598561896611383e-02,	 1.531556027004567e-02,
				 1.463087065627697e-02,	 1.393493692774401e-02,
				 1.323115989909443e-02,	 1.252285567837853e-02,
				 1.181329618398746e-02,	 1.110566617194871e-02,
				 1.040302331611342e-02,	 9.708311513369797e-03,
				 9.024324608807328e-03,	 8.353676447074240e-03,
				 7.698822264988726e-03,	 7.062014104279350e-03,
				 6.445325874227459e-03,	 5.850570227535509e-03,
				 5.279415155171049e-03,	 4.733238438935366e-03,
				 4.213233003347200e-03,	 3.720375755386576e-03,
				 3.255386488363327e-03,	 2.818791793300855e-03,
				 2.410920127464540e-03,	 2.031873628978360e-03,
				 1.681579756812664e-03,	 1.359749698954905e-03,
				 1.065978752364769e-03,	 7.995904472920495e-04,
				 5.599142515163203e-04,	 3.460113691458050e-04,
				 1.568691933439616e-04,	-8.594717640895825e-06,
				-1.516021567916148e-04,	-2.734273006941576e-04,
				-3.753837344550358e-04,	-4.588682259308329e-04,
				-5.252686628355063e-04,	-5.760341781234181e-04,
				-6.124486551146518e-04,	-6.361097347320060e-04,
				-6.482378016300279e-04,	-6.502753220265006e-04,
				-6.435464593668489e-04,	-6.292324022329137e-04,
				-6.085612035359574e-04,	-5.826957473746211e-04,
				-5.526349048759427e-04,	-5.193247290669658e-04,
				-4.836292956512548e-04,	-4.466426643827939e-04,
				-4.085850549101987e-04,	-3.708614964568210e-04,
				-3.333506997786936e-04,	-2.967199456778411e-04,
				-2.616217785107975e-04,	-2.282544203200737e-04,
				-1.967504435866056e-04,	-1.673824131170590e-04,
				-1.404273520847886e-04,	-1.159940398487160e-04,
				-9.403278250922984e-05,	-1.898407653893172e-04 };

// FFT	(in app_EWO_fft.c)
//#define 	MAX_N_FFT 8192
double				Gf_EWO_signal	[16384];			// Gd_EWO_FFT_MAX_N * 2
int					Gi_EWO_workarea	[93];				//(int)app_math_sqrt(Gd_EWO_FFT_MAX_N) + 2];
double 				Gf_EWO_sin_table[8192];				// Gd_EWO_FFT_MAX_N

double				G14f_EWO_signal	[2048];			// Gd_EWO_FFT_MAX_N * 2
int					G14i_EWO_workarea	[40];				//(int)app_math_sqrt(Gd_EWO_FFT_MAX_N) + 2];
double 				G14f_EWO_sin_table[1024];				// Gd_EWO_FFT_MAX_N


// ***************
// ***** EFD *****
// ***************
// Work area
short			Gs_EFD_work    [1280];		// for Packet data: 128Hzx5sec or 8Hzx5secx4spin
double			Gf_EFD_work    [3200];		// ***TMP*** for Decimation 128x5x5 = 3200MAX
double			Gf_EFD_DEC_work[3200];		// ***TMP*** for Decimation 128x5x5 = 3200MAX
double			Gf_EFD_re[64];			// for FFT
double			Gf_EFD_im[64];			// for FFT
unsigned char		Guc_EFD_FFT [16];		// for FFT
unsigned char		Guc_EFD_FFT0[16][32];		// for FFT
//
unsigned int		Gui_EFD_Spin;			//	DPB data:	0:Y  1:X
//unsigned char		Guc_EFD_packet[256];		//

// Data mode
unsigned char		Guc_EFD_SPB_ena;		//	ENA/DIS for SPB (B0:WPT-S1 B1:WPT-S2 B2:MEF-S1 B3:MEF-S2)	<<HK>>
unsigned char		Guc_EFD_DPB_ena;		//	ENA/DIS for DPB (B0:WPT-S  B1:MEF-S)				<<HK>
unsigned char		Guc_EFD_SlowSweep;
unsigned char		Guc_EFD_Bias1;			//	Bias1
unsigned char		Guc_EFD_Bias2;			//	Bias2

// DPB: data
short				Gs_EFD_DPB_Data[3200][2];	//	DPB data:	0:Y  1:X  (128 x5(Sec) x5(spin))
unsigned short		Gus_EFD_DPB_Size [5];		//	5-spin
unsigned int		Gui_EFD_DPB_Ti   [5];		//	5-spin
unsigned short		Gus_EFD_DPB_TiSun[5];		//	5-spin

// SPB: data
short				Gs_EFD_SPB_Data[800][4];	//	SPB data:	0:Y1 1:X1 2:Y2 3:X2   (32 x 5(Sec) x 4(spin))
unsigned short		Gus_EFD_SPB_Size [5];		//	5-spin
unsigned int		Gui_EFD_SPB_Ti   [5];		//	5-spin
unsigned short		Gus_EFD_SPB_TiSun[5];		//	5-spin

// SWEEP: data
unsigned short		Gus_EFD_SWEEP_Size;
unsigned int		Gui_EFD_SWEEP_Ti;

// --- DATA EXCHANGE: SOR/EFD
unsigned char		Guc_SOR_data_status0;		// SORBET:	Status
unsigned char		Guc_SOR_data_status;		// SORBET:	Status
unsigned char		Guc_EFD_data_status;		// EFD:	Status


// ************************
// ***** Hungary:ISDM *****
// ************************
//unsigned char		Guc_EWO_ISDM_tbl[5048];			//	****TMP****
unsigned char		Guc_EWO_ISDM_tbl[74];			//	rev. 2012.11.26 Imachi
//			Contents-2	Hungary					5048B
//				------------------------------------------
//				Uint     (4byte)      2    X 4byte =   8
//				Short int(2byte) (13+40)   X 2byte = 106
//				Uchar    (1byte)       5   X 1byte =   5
//				------------------------------------------
//				sub Total                            119B x 8 =  952 B
//				
//				+	short int RefSpect[256][8] = 2x256x8  = 4096 byte
//				====================================================
//				total                                           5048 B
//			--------------------------------------------------------
//			
//			<ORDER>
//				typedef struct conf {
//			    	uint    E_Bgnd;
//			    	uint    E_Proc;
//			    	word    Min_Max_E_Step;
//			    	byte    Min_Max_Lines;
//			    	word    NB_SNR;
//			    	word    NB_Pw_SN;
//			    	byte    NB_Pw_Lines;
//			    	word    NB_QF;  
//			    	word    Mid_SNR;
//			    	word    Mid_Pw_SN;
//			    	byte    Mid_Pw_Lines;
//			    	word    Mid_QF;  
//			    	word    WB_SNR;
//			    	word    WB_Pw_SN;
//			    	byte    WB_Pw_Lines;
//			    	word    WB_QF;  
//			    	word    Multi_SNR;
//			    	word    Multi_Pw_SN;
//			    	byte    Multi_Pw_Lines;
//			    	word    Multi_QF; 
//			    	word    Init[40];
//				}__attribute__((__packed__)) configstr;
//				=============================================
//				configstr Config[8];
//				unsigned short int RefSpect[256][8];
// *****************************************************************
