/*******************************************************************************
*   W[      FApplication Header                                   *
*   W[x    Fapp_MGF.h                                            *
*   ^XN敪          Fwb_                                               *
*   @\                Fdefine/Struct/Variable/Prototype                     *
*   gp̒        FɂȂ                                             *
*   				F  EDIT́AMGFg                                  *
*   쐬E쐬      F2009/04/07    Y.K.                                   *
*   XVEXV      F2011/09/02    Matsuoka                               *
*                       F2011/09/14    Matsuoka remove Gui_MGF_sunpulseTI_*   *
*                       F2011/10/11    Y.K. (SystemϐƂ̐)              *
*   E      F2012/05/29    A. Matsuoka Guc_MGF_TLM_stat ̃TCY  *
*   E      F2012/06/06    A. Matsuoka                            *
*   E      F2013/11/08    A. Matsuoka                            *
*                                       SW parameter set command length        *
*   E      F2013/11/19    A. Matsuoka                            *
*******************************************************************************/

#include "dpu_api.h"
#include "app_common.h"

/* MGF basic parameters */
extern unsigned char Guc_node_mgf[2] ;
extern unsigned short Gus_MGF_packet_def_n_in_block ;  /* defined packet number in a block = 9 */
extern unsigned short Gus_MGF_data_def_n_in_packet ;  /* defined data number in a packet = 18 */
extern unsigned short Gus_MGF_app_m[2] ;
extern long Gl_MGF_mss_block_len ;  // Block length of MGF mission data

extern long Gl_MGF_mss_packet_len ;
extern long Gl_MGF_dat_packet_len ;
extern unsigned short Gus_MGF_TLM_CO_header_length ;

/* Parameters for commanding */
extern long Gl_MGFO_Cmm_n, Gl_MGFI_Cmm_n, Gl_MGFO_Mrr_n, Gl_MGF_SwP_n[2] ;
extern unsigned char Guc_MGFO_Cmm_Param[30][3], Guc_MGFO_Mrr_Param[32][3], Guc_MGFI_Cmm_Param[4] ;
extern unsigned char Guc_MGF_Sw_Param[2][5][20] ;
extern unsigned char Guc_MGF_TLM_Param[2][8] ;
extern short Gs_MGF_dt_offset[2] ;  // new 20110902

/* Parameters for mission data store */
extern long Gl_MGF_mss_block[2] ;
extern unsigned char Guc_MGF_raw[2][5][9][202] ;  // 6 -> 5 20131119
extern long Gl_MGF_full[2][3][780][3], Gl_MGF_last_1s[2][3][130][3] ;
extern long Gl_MGF_full_dt[2][3][780], Gl_MGF_last_1s_dt[2][3][130] ;  // type change 20110902
extern unsigned char Guc_MGF_last_1s_n[2][3] ;
extern unsigned short Gus_MGF_full_length, Gus_MGF_last_1s_length ;  // new 20110902
extern unsigned int Gui_MGF_TLM_block_TI[2];			// , Gui_MGF_TLM_lastblock_TI[2] ;		**** rev by YK 111011 ***

/* Parameters for HK data */
extern unsigned char		Guc_MGF_HK[2][20];				// Buffer for MGF User HK Output

/* buffer status */
extern unsigned short Gus_MGF_buff_in_store[2] ; // curently storing buffer
extern unsigned short Gus_MGF_buff_n[2][3] ;  // data count stored in the buffer
extern unsigned short Gus_MGF_buff_stat[2][3] ;  // buffer status
extern unsigned long Gul_MGF_buff_ti[2][3] ;  // TI of the buffer
extern unsigned long Gul_MGF_spin_n[2] ;

/* Physical parameters */
extern unsigned short Gus_MGF_t_step[2] ;
extern unsigned short Gus_MGF_dt_unit[2] ;  // typical dt unit in usec
extern unsigned short Gus_MGF_ti_unit ;  // TI unit in usec
extern unsigned short Gus_MGF_ti_step_1hz ;
extern unsigned long Gul_MGF_spin_prd[2] ;
extern long Gl_MGF_ave[2][3] ; // average for spin period
extern long Gl_MGF_sub[2][3] ;  // specified major component to subtract for compression
extern long Gl_MGF_mjr[2][3] ;  // major component for compression
extern short Gs_MGF_off[2][3] ;  // offset to subtract from average for spin fit
extern short Gs_MGF_spin_fit[2][3][3] ;  // new 20110902

extern short Gs_MGF_cnv[2][3][3][3] ;  // changed into array 20110901













extern short Gs_MGF_cnv_const_xy ;
extern short Gs_MGF_cnv_const_z ;
extern unsigned short Gus_MGF_rng_shift[2][3] ;
extern unsigned char Guc_MGF_1s_n[2] ;
extern short Gs_MGF_TRG[2][4] ;  // new 20110902

/* Mission telemetry data parameter and storage */
extern unsigned char Guc_MGF_mjr_flag[2][3] ;  // flag of the major component
extern unsigned char Guc_MGF_shift_flag[2][3] ;  // flag of the bit shift
extern unsigned char Guc_MGF_TLM_out[2][3] ;  // flag of the telemetry output for L, M, H
extern unsigned char Guc_MGF_TLM_rate[2][3] ;  // flag of the telemetry mode for L, M, H
extern unsigned char Guc_MGF_TLM_header_com[2][15], Guc_MGF_TLM_header_ML[2][22] ;  // corrected 20110902 18->15, 20110902 26->24
extern unsigned long Gul_MGF_ML_start_ti[2] ;
extern unsigned char Guc_MGF_hmode[2][810], Guc_MGF_8hz[2][310], Guc_MGF_4hz[2][170] ;
extern unsigned short Gus_MGF_Sw_Param_n[2] ;
// extern unsigned short Gus_MGF_TLM_ML_header_length ;  // delete 20131108 Matsuoka
#ifdef TLM_STAT
extern unsigned char Guc_MGF_TLM_stat[2][128] ;  // changed 20120529
extern long Gl_MGF_TLM_stat_len ;  // changed 20120529
#endif

extern unsigned char Guc_MGF_TLM_Mmode[2][1500] ;  // data put to M-mode packet, add 20131108 Matsuoka
extern unsigned char Guc_MGF_TLM_Lmode[2][400]  ;  // data put to L-mode packet, add 20131108 Matsuoka
extern int Gi_MGF_TLM_data_n[2][3] ;  // data length of the packet, add 20131108 Matsuoka
extern unsigned char Guc_MGF_TLM_spin_n[2][3] ;  // number of spins in the packet, add 20131108 Matsuoka
extern unsigned int Gui_MGF_TLM_ti[2][3] ;  // start TI of the packet, add 20131108 Matsuoka

