/*******************************************************************************
*                                                                              *
*   W[      F~bVf[^W擾                         *
*   W[x    Frap_mm_getMisDataPlan                                *
*   ^XN敪          F璷Cu                                       *
*   @\                F~bV@̃~bVf[^WɊւ   *
*                         擾                                             *
*                                                                              *
*   R[OV[PXFint rap_mm_getMisDataPlan(nodeID,missionDataID,&info)*
*                   Fint               nodeID       F~bV@ID    *
*                         int               missionDataIDF~bVf[^ID  *
*                         M_T_MIS_DATA_PLAN info         F~bVf[^*
*   ߂l              F ( <0 :ُ , 0:)                        *
*                          0 FI                                        *
*                         -1 FnodeID~bV@IDłȂ                  *
*   gp̒        FȂ                                                 *
*   G[          FȂ                                                 *
*                                                                              *
*******************************************************************************/
#include "dpu_api.h"
#include "dpu_api_proto.h"
#include "rap_api.h"
#include "rap_define.h"             /* define`               */
#include "rap_variable.h"           /* O[oϐ錾       */
#include "rap_func.h"               /* ֐vg^Cv錾     */
#include "app_rdn_core.h"

#define RMAP_HDR_SIZE_WC 16
#define RMAP_HDR_SIZE_RR 12
#define RMAP_FTR_SIZE    1

int rap_mm_getMisDataPlan( int nodeID,
                           int missionDataID,
                           M_T_MIS_DATA_PLAN *info )
{
    int     i_dataSize;
    int     i_rplySize;
    int     i_blkSize;
    char    c_msChannel;
//    M_T_DPU_INFO t_dpuInfo;
    char    c_dpuIndex;    /* DPUCfbNX       */
    
    
    if( nodeID == RA_d_NODE_EWO_E || nodeID == RA_d_NODE_EWO_B )
    {
        
        if      ( missionDataID == 0 ) {
            i_dataSize = ui_ewoWriteSize[missionDataID];
            i_rplySize = (i_dataSize + RMAP_HDR_SIZE_WC + RMAP_FTR_SIZE)
                         + ((0x100000 - (i_dataSize + RMAP_HDR_SIZE_WC + RMAP_FTR_SIZE)) & 0x0F);
            /* 80=5000ms(sunPulse)/(62.5ms/8)(pPbgo͊Ԋu) */
            i_blkSize = i_rplySize * 640;
        }
        else if ( missionDataID == 1 ) {
            i_dataSize = ui_ewoWriteSize[missionDataID];
            i_rplySize = (i_dataSize + RMAP_HDR_SIZE_WC + RMAP_FTR_SIZE)
                         + ((0x100000 - (i_dataSize + RMAP_HDR_SIZE_WC + RMAP_FTR_SIZE)) & 0x0F);
            /* 80=5000ms(sunPulse)/(62.5ms/8)(pPbgo͊Ԋu) */
            i_blkSize = i_rplySize * 640;
        }
        else if ( missionDataID == 2 ) {
            i_dataSize = ui_ewoWriteSize[missionDataID];
            i_rplySize = (i_dataSize + RMAP_HDR_SIZE_WC + RMAP_FTR_SIZE)
                         + ((0x100000 - (i_dataSize + RMAP_HDR_SIZE_WC + RMAP_FTR_SIZE)) & 0x0F);
            /* 2packet / sunPulse  200HoE_ */
            i_blkSize = (i_rplySize * 2) + ((0x100000 - (i_rplySize * 2)) & 0x1FF);
        }
        else if ( missionDataID == 3 ) {
            i_dataSize = ui_ewoWriteSize[missionDataID];
            i_rplySize = (i_dataSize + RMAP_HDR_SIZE_WC + RMAP_FTR_SIZE)
                         + ((0x100000 - (i_dataSize + RMAP_HDR_SIZE_WC + RMAP_FTR_SIZE)) & 0x0F);
            /* 80=5000ms(sunPulse)/(62.5ms/8)(pPbgo͊Ԋu) */
            i_blkSize = i_rplySize * 640;
        }
        else {
            return -1;
        }

        info->uc_cpuInt     = 0;
        info->uc_number     = 0;
        info->uc_interval   = 0;
        info->ui_readSize   = i_dataSize;
        info->ui_replySize  = (unsigned int)i_rplySize;
        info->ui_blockSize  = (unsigned int)i_blkSize;
        
    }else{
        
        c_msChannel = Gc_CHID[ nodeID ];
        
        if( nodeID <= RA_d_NODE_MGF_O)  /* DPUCfbNXC */
        {
            c_dpuIndex = 0; /* DPU1 */
        }else{
            c_dpuIndex = 1; /* DPU2 */ 
        }
        
        if( c_msChannel >= 0 && c_msChannel < RA_d_MISSION_NUM)
        {
            i_dataSize = RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_msChannel].ui_readSize;
            i_rplySize = (i_dataSize + RMAP_HDR_SIZE_RR + RMAP_FTR_SIZE)
                         + ((0x100000 - (i_dataSize + RMAP_HDR_SIZE_RR + RMAP_FTR_SIZE)) & 0x0F);
            i_blkSize  = i_rplySize * (int)RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_msChannel].uc_number;
            
        }else{

// ---comment out:110615 ---	            rap_cmm_putDbgTlm( c_msChannel );
            return -1;
        }

        info->uc_cpuInt     = RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_msChannel].uc_cpuInt;
        info->uc_number     = RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_msChannel].uc_number;
        info->uc_interval   = RA_Gt_missionInfo[(int)c_dpuIndex][(int)c_msChannel].uc_interval;
        info->ui_readSize   = i_dataSize;
        info->ui_replySize  = (unsigned int)i_rplySize;
        info->ui_blockSize  = (unsigned int)i_blkSize;
    }
    

    return 0;
}

